/*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 1, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* AUTHOR: Angelo Rosiello
* CONTACT: angelo@rosiello.org, rosiello.angelo@virgilio.it, angelo@dtors.net
*  
*/


#include <dirent.h>
#include "issue.h"

char *reader(char *);

char *check_version()
{
	//REQUIRES: "/etc" existance
	//EFFECTS : returns the distro if It's known from database

	int i, verify;
	DIR *etc;
  	struct dirent *de;
	char *distro = (char *)malloc(25);
	for(i = 0; i < 25; i++) distro[i] = '\0'; 					//cleaning from garbage
	verify = 1;
  	etc = opendir ( "/etc" );

  	while ( de = readdir ( etc ) )

   	{
		/* 
		checking for the existance of /etc/*version* or
		/etc/*release* files to read from.
		*/
    		if ( (strstr(de->d_name, "release") != NULL) && (verify == 1))  
		{
			distro = (char *)de->d_name;
			distro = (char *)reader(distro);
			if(os_known(distro))
			{ 
				printf("Ok, We are on %s\n", distro);
				verify = 0;
			}
			else if(!os_known(distro)) verify = 1;
			
		}

                if ( (strstr(de->d_name, "issue") != NULL) && (verify == 1))
                {
			distro = (char *)de->d_name;
                        distro = (char *)reader(distro);
                        if(os_known(distro))
                        {
                                printf("(rpf) Ok, We are on %s, Let's go on...\n", distro);
                                verify = 0;
                        }
                        else if(!os_known(distro)) verify = 1;
                }

   	}
  	closedir ( etc );
	return (distro);
 }

char *reader(char *file)
{
	//REQUIRES: *file existance
	//EFFECTS : returns distro calling issue(*file) 

	int i;
	char *distro = (char *)malloc(25);
        char directory[] = "/etc/";
        char PATH[25];

	for(i = 0; i < 25; i++) distro[i] = '\0';
        if(strlen(file) > 18)
	{               
        	printf("File Name too long.\n");
                exit(0);
        }
        sprintf(PATH, "%s%s", directory, file);
        if(strlen(issue(PATH)) > 24)                            				//security checking
        {
		printf("File Result too long\n");
                exit(0);
        }
        strcpy(distro, issue(PATH));                            				//get result from issue()
	return(distro);
}
