/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * AUTHOR: Angelo Rosiello
 * CONTACT: angelo@rosiello.org, rosiello.angelo@virgilio.it, angelo@dtors.net
 */

#include "issue.h"

char *issue(char *issue_file)
{
 	//REQUIRES: "issue_file" existance
        //EFFECTS : returns distro using this algorithm rules

	int fd, i, j, eof;
	char ch;
	char *distro = (char *)malloc(25);
	char *nothing = (char *)malloc(7);

	for(i = 0; i < 25; i++) distro[i] = '\0';
	for(i = 0; i < 7; i++) nothing[i] = '\0';
	nothing = "NOTHING";
	i = 1; j = 0; eof = 1;                                    

	fd = open(issue_file, 0644, O_RDONLY);
	if(fd <= 0) perror("Proc Distro");
	assert(fd > 0);                                 

	while(i && eof)                                 
    	{
		eof = read(fd, &ch, 1);                 
		if(ch != ' ' && ch != '\n')   distro[j] = ch;
		j++;
		if(ch == ' ' || ch == '\n') i = 0;      	}

	if(eof == 0) return(nothing);

	while(eof)				 
	{
		eof = read(fd, &ch, 1);
		if(ch == '1' || ch == '2' || ch == '3'
		   || ch == '4' || ch == '5' || ch == '6'
		   || ch == '7' || ch == '8' || ch == '9'
		   || ch == '.' || ch == ',' || ch == '0')
		{
			distro[j-1] = ch;
			j++;
		}
	}
	return(distro);

}
