/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * AUTHOR: Angelo Rosiello
 * CONTACT: angelo@rosiello.org, rosiello.angelo@virgilio.it, angelo@dtors.net
 */


#include "search.h"

char *match(char *argument)
{
	//REQUIRES: argument != NULL
	//EFFECTS : returns FOUND if the package matches
	//          else STOP
	int fd, buffer, status;
	int register i, j;
	char ch;
	char memory[1024], file[64];
	
	buffer = 1;
	status = 1;
	for(i = 0; i< 1024; i++) memory[i] = '\0';

	sprintf(file, "/tmp/.rpf-%d", getuid());
	fd = open(file, O_RDONLY, 0644);
	if(fd < 0) perror("File");
	assert(fd >= 0);

	i = 0;
	while(buffer)
	{
		buffer = read(fd, &ch, 1);
		if(ch != '\n' && i < 1023)
		{
			memory[i] = ch;
			i++;
		}
		else if(ch == '\n')
		{
			if(strstr(memory, argument) != NULL)
			{
				printf("(rpf) %s\n", memory);
				status = 1;		
			}
			for(j = 0; j < i; j++) memory[j] = '\0'; 
			i = 0;
		}
	}
	close(fd);
	if(status == 1) return("FOUND");
	
	return("stop");
}
