/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * AUTHOR: Angelo Rosiello
 * CONTACT: angelo@rosiello.org, rosiello.angelo@virgilio.it, angelo@dtors.net
 */


#include "search.h"


void addr_initialize();

char *web(char *url, char *ip)
{
	//REQUIRES: url != NULL && ip != NULL
	//EFFECTS : all the database in the file
	char ch;
	struct sockaddr_in server_addr;
	int PORT, sd, error, buffer, fd, begin;
	int register i, j;
	char get[256], memory[1024], cleaner[1024], old[1024], file[64];
	char capo = '\n';
	
	PORT = 80;
	buffer = 1;
	for (i = 0; i < 256; i++) get[i] = '\0';
	for (i = 0; i < 1024; i++) memory[i] = '\0';
	for (i = 0; i < 1024; i++) cleaner[i] = '\0';
	for (i = 0; i < 1024; i++) old[i] = '\0';

	addr_initialize(&server_addr, PORT, (long)inet_addr(ip));
	sprintf(get, "GET %s HTTP/1.0\n\n", url);
	sprintf(file, "/tmp/.rpf-%d", getuid());

	/* Connection and writing informations in the temp file */
	fd = open(file, O_CREAT | O_WRONLY | O_TRUNC, 0644);
	if(fd < 0) perror("File");
	assert(fd >= 0);	

	sd = socket(AF_INET, SOCK_STREAM, 0);
	if(sd < 0) perror("Socket");
	assert(sd >= 0);
		
	error = connect(sd, (struct sockaddr *) &server_addr, sizeof(server_addr));
        if(error != 0)
	{
		perror("CONNECT");
	        exit(0);
        }
        i = 0; j = 0;
        if(error == 0) printf("(rpf) Connected to: %s\n", ip);
	buffer = 1;
	write(sd, get, strlen(get));
	
	while(buffer != 0)
	{
		buffer = recv(sd, &ch, 1, 0);
	 	if(ch == '\n' || ch == ' ')
	 	{
			begin = 0;
			if(strncasecmp(memory, "href=", 5) == 0)
			{
				i = 0;
				while(!begin && i < 1024)
				{
					if(memory[i] == '"')
					{
                                        	i++;
                                                begin = 1;
						while(i < 256)
						{
							if(memory[i] == '"')
							{
								if(!strcmp(old, cleaner))
								{	
									i = 300;	
									break;
								}
								write(fd, cleaner, strlen(cleaner));
								write(fd, &capo, 1);
								strcpy(old, cleaner);
								i = 300;
								
							}
						//	write(fd, &memory[i], 1);
							cleaner[j] = memory[i];
							i++; j++;
						}
					}
					i++;
				}
			}
			for(i = 0; i < 1024; i++) cleaner[i] = '\0';			
			i = 0; j = 0;	
	 	}
	 	else if(ch != '\n' && ch != ' ')
	 	{
			
			memory[i] = ch;
		 	i++;
	 	}
	}
	close(sd);
	close(fd);
	return("ok");	
}
void addr_initialize (struct sockaddr_in *address, int port, long IPaddr) 
{
	address -> sin_family = AF_INET;
        address -> sin_port = htons((u_short)port);
        address -> sin_addr.s_addr = IPaddr;
}


